use pkmn_lib_interface::app_interface::list::ImmutableList;
use pkmn_lib_interface::app_interface::{get_hash, BattleLibrary, DataLibrary, EffectParameter};
use pkmn_lib_interface::dbg;
use pkmn_lib_interface::handling::{Script, ScriptCapabilities};

pub struct TestScript {}

impl Script for TestScript {
    fn new() -> Self {
        TestScript {}
    }
    fn destroy(&self) {}

    fn get_name(&self) -> &str {
        "TestScript"
    }

    fn get_capabilities(&self) -> &[ScriptCapabilities] {
        &[ScriptCapabilities::Initialize]
    }

    fn on_initialize(
        &self,
        library: &BattleLibrary,
        parameters: Option<ImmutableList<EffectParameter>>,
    ) {
        let l = library.data_library();
        let ml = l.move_library();
        let m = ml.get_by_hash(const { get_hash(b"tackle") }).unwrap();
        dbg!("found move!");
        dbg!("{:?} has {} base power", m.name().str(), m.base_power());
        dbg!(
            "Found a parameter with value: {}",
            parameters.unwrap().get(0).unwrap()
        )
    }
}
