use crate::app_interface::StaticData;
use crate::{impl_extern_ctor, ExternRef};

pub struct BattleLibrary {
    ptr: ExternRef<BattleLibrary>,
}

impl_extern_ctor!(BattleLibrary);

impl BattleLibrary {
    pub fn data_library(&self) -> StaticData {
        unsafe { StaticData::new(battle_library_get_static_data(self.ptr)) }
    }
}

extern "wasm" {
    fn battle_library_get_static_data(ptr: ExternRef<BattleLibrary>) -> ExternRef<StaticData>;
}
